using Edu.Common.Enum;
using Edu.Model.Entity.WeChat;
using Edu.Model.ViewModel.WeChat;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using VT.FW.DB.Dapper;

namespace Edu.Repository.WeChat
{
    /// <summary>
    /// 投稿素材分组仓储层
    /// </summary>
    public class RB_Contribute_MediumGroupRepository : BaseRepository<RB_Contribute_MediumGroup>
    {
        /// <summary>
        /// 获取分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="count"></param>
        /// <param name="demodel"></param>
        /// <returns></returns>
        public List<RB_Contribute_MediumGroup_ViewModel> GetPageList(int pageIndex,int pageSize,out long count, RB_Contribute_MediumGroup_ViewModel demodel)
        {
            DynamicParameters parameters = new DynamicParameters();
            string where = $@" 1=1 and r.{nameof(RB_Contribute_MediumGroup_ViewModel.Status)} =0";
            if (demodel.Group_Id > 0)
            {
                where += $@" and r.{nameof(RB_Contribute_MediumGroup_ViewModel.Group_Id)} ={demodel.Group_Id}";
            }
            if (!string.IsNullOrEmpty(demodel.Name))
            {
                where += $@" and r.{nameof(RB_Contribute_MediumGroup_ViewModel.Name)} like @Name";
                parameters.Add("Name", "%" + demodel.Name + "%");
            }

            string sql = $@" 
SELECT * From RB_Contribute_MediumGroup r
WHERE {where} 
ORDER BY r.Id DESC ";
            return GetPage<RB_Contribute_MediumGroup_ViewModel>(pageIndex, pageSize, out count, sql, parameters).ToList();
        }

        /// <summary>
        /// 获取列表
        /// </summary>
        /// <param name="demodel"></param>
        /// <returns></returns>
        public List<RB_Contribute_MediumGroup_ViewModel> GetList(RB_Contribute_MediumGroup_ViewModel demodel)
        {
            DynamicParameters parameters = new DynamicParameters();
            string where = $@" 1=1 and r.{nameof(RB_Contribute_MediumGroup_ViewModel.Status)} =0";
            if (demodel.Group_Id > 0)
            {
                where += $@" and r.{nameof(RB_Contribute_MediumGroup_ViewModel.Group_Id)} ={demodel.Group_Id}";
            }
            if (!string.IsNullOrEmpty(demodel.MediumGroupIds))
            {
                where += $@" and r.{nameof(RB_Contribute_MediumGroup_ViewModel.Id)} in({demodel.MediumGroupIds})";
            }
            if (!string.IsNullOrEmpty(demodel.Name))
            {
                where += $@" and r.{nameof(RB_Contribute_MediumGroup_ViewModel.Name)} like @Name";
                parameters.Add("Name", "%" + demodel.Name + "%");
            }

            string sql = $@" 
SELECT * From RB_Contribute_MediumGroup r
WHERE {where} 
ORDER BY r.Id DESC ";
            return Get<RB_Contribute_MediumGroup_ViewModel>(sql, parameters).ToList();
        }

    }
}
